(* History:
2010-02-21, 16:44, hk: First version.
                                      * If name contains "," reverse order!--DONE
                                      * get original text--DONE
					   * check if already quoted, if not-> quote--DONE
					   * Leere Zeilen auch quoten--DONE
					   * Reply & set new content--DONE

					Bug: Erkennung des schon gequoteten buggt!--?

ToDo:

*)


tell application "Mail"
	#	tell message viewer
	#		get selected messages 
	#	end tell
	set selectedMessages to selection
	set selectedMessagesCount to (count selectedMessages)
	if selectedMessagesCount > 0 then
		if selectedMessagesCount > 23 then
			set res to display dialog "Are you sure you want to reply on " & selectedMessagesCount & " messages?" buttons {"No", "Maybe", "Yes"}
			if button returned of res is not "Yes" then
				return
			end if
		end if
		(* Now, do the magic! *)
		repeat with selectedMessage in selectedMessages
			tell selectedMessage
				set smSender to sender
				(* cut the email-address *)
				tell me to set smSenderName to cutString of smSender by "<"
				(* If name contains "," cut the part before the "," and add it at the end (this way "Doe, John" will get "JD" instead of "DJ") *)
				if smSenderName contains "," then
					log "foo"
					tell me to set smSenderNameSurname to cutString of smSenderName by ","
					log smSenderNameSurname
					tell me to set smSenderNameFirstname to cutStringRemainder of smSenderName by ","
					log smSenderNameFirstname
					set smSenderName to (smSenderNameFirstname & " " & smSenderNameSurname) as rich text (* yes, that's ugly *)
					log smSenderName
				end if
				(* get initials of the name *)
				tell me to set smInitials to initialsOfName(smSenderName)
				(* get text of mail and walk lines... http://www.mactech.com/articles/mactech/Vol.21/21.07/WorkingWithText/index.html *)
				set smText to content
				set smTextQuoted to ""
				#log smText
				#set smTextLineCount to count paragraphs of smText
				
				(* Zeilen (=Paragraphs) abklappern *)
				repeat with p in (paragraphs of smText)
					
					(* Get line length *)
					set lineLength to (length of p)
					if lineLength > 5 then
						set lineLength to 5
					end if
					
					if lineLength > 0 then
						set pBegin to characters 1 thru lineLength of p
					else
						set pBegin to ""
					end if
					
					if pBegin contains ">" then
						(* is quoted -> just concatenate strings *)
						#log "already quoted: " & pBegin
						set smTextQuoted to smTextQuoted & (p as string) & return
					else
						
						#if pBegin does not contain ">" then
						(* not quoted yet, quote! *)
						set smTextQuoted to smTextQuoted & smInitials & "> " & (p as string) & return
						#else
						#	(* already quoted *)
						#	set smTextQuoted to smTextQuoted & (p as string) & return
						#end if
						#else
						#set smTextQuoted to smTextQuoted & (p as string) & return
					end if
					
				end repeat (* repeat with paragraphs *)
				log "quoted text: " & return & smTextQuoted
			end tell # tell selectedMail
			
			(* Backup quoting behaviour *)
			tell application "Mail" to set quotingSetting to quote original message
			tell application "Mail" to set quote original message to false
			
			(* now reply *)
			set newMessage to reply selectedMessage with opening window and reply to all
			if newMessage is false then
				log "Gee, reply failed."
			else
				tell newMessage
					log newMessage
					#set content of newMessage to "foo" -- smTextQuoted
					#	make new content with properties {text:"smTextQuoted"}
					log (content)
					log (subject)
					log (sender)
					log (to recipients)
					#make new to recipient with properties {address:"MY ADDRESS"}
					log (to recipients)
					#make new content with t
					#log "s: " & (contents as text)
					set content to "foo"
					set content to smTextQuoted
					#make new content with properties {text:"MY text"}
				end tell
			end if # reply worked
			
			(* Restore quoting behaviour *)
			tell application "Mail" to set quote original message to quotingSetting
			
		end repeat (* repeat with mails *)
	else
		log ("You might want to select a message first")
	end if
end tell

(* Now get the first characters of every word (Initials) *)
on initialsOfName(sendername)
	set initials to ""
	repeat with oneWord in (words of sendername)
		set initials to initials & first character of oneWord
	end repeat
	return initials
end initialsOfName

(* cuts all the text following the first occurance of the searchstring 'd' *)
to cutString of t by d
	set oldd to text item delimiters
	set text item delimiters to d
	set t to t's text items
	set t to first item in t
	set text item delimiters to oldd
	t
end cutString

(* returns what cutString has cut off! *)
to cutStringRemainder of t by d
	set oldd to text item delimiters
	set text item delimiters to d
	set t to t's text items
	set wordCount to count t
	if (wordCount > 1) then
		set t to items 2 through wordCount in t
	end if
	set text item delimiters to oldd
	t
end cutStringRemainder

(* Diese Funktion ersetzt einen String innerhalb eines strings durch einen anderen String. Quelle: http://macscripter.net/viewtopic.php?id=13008 *)
to changeSubString of t from s to r
	set d to text item delimiters
	set text item delimiters to s
	set t to t's text items
	set text item delimiters to r
	tell t to set t to beginning & ({""} & rest)
	set text item delimiters to d
	t
end changeSubString
