(* Main *)
on run (argv)
	
	if false then
		(* Save previous clipboard contents *)
		set oldClipboard to the clipboard
		try
			my logToConsole("oldClipboard: " & oldClipboard)
		on error (e)
			my logToConsole("oldClipboard: was not loggable, maybe not TEXT?")
		end try
		
		(* Clear Clipboard *)
		set the clipboard to ""
		
		(* Get selected text *)
		set someword to ""
		repeat 23 times
			(* Try to copy the selection to clipboard, might fail, if some more modifiers down (f.e. if you launch this script with FastScripts and a Shortcut that uses option, control or shift..) *)
			try
				tell application "System Events" to keystroke "c" using {command down}
				(* Try to copy the clipboard contents *)
				try
					set someword to the clipboard as text
					#		if (oldClipboard is not equal to someword and someword is not "") then
					exit repeat
					#		end if
				on error (e)
					my logToConsole("Error while copying selection to clipboard (cmd-c): " & e)
				end try
			on error (e)
				my logToConsole("Error while copying the clipboard: " & e)
			end try
			delay 0.1
		end repeat
	end if
	
	(* If copying to and from clipboard worked *)
	my logToConsole("someword: " & someword)
	if someword is not "" then
		(* Translate text *)
		tell me to set someword to rot47(someword)
		set the clipboard to someword
		
		#		(* Paste the translated text *)
		#		tell application "System Events" to keystroke "v" using {command down}
	end if
	
	#	(* Restore previous clipboard *)
	#	delay 2 (* Essential - The cmd-V might not been fully executed at this time when we restore the clip! (THIS IS SERIOUS! DON'T LAUGH!) *)
	#	set the clipboard to oldClipboard
end run


(* ******** Methods ******** *)
to rot5(givenString)
	tell me to set result to rotXX(givenString, 5)
	return result
end rot5

to rot13(givenString)
	tell me to set result to rotXX(givenString, 13)
	return result
end rot13

to rot5And13(givenString)
	tell me to set result to rotXX(givenString, 5)
	tell me to set result to rotXX(result, 13)
	return result
end rot5And13

to rot18(givenString) (* I'd say http://www.rot18.com/ is wrong! Those do ROT13+ROT5 instead of ROT18! As does my monoalphabetic substitution code converter! F*CK! *)
	tell me to set result to rotXX(givenString, 18)
	return result
end rot18

to rot47(givenString)
	tell me to set result to rotXX(givenString, 47)
	return result
end rot47

to rotXX(givenString, rotFactor)
	set returnString to ""
	#	set runs to 2
	set alphabet to "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
	set ascii33to126 to "!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
	if rotFactor is 47 then
		set rotAlphabet to ascii33to126
		#		set runs to 1 (* case is automatically done by 47 *)
	else
		set rotAlphabet to alphabet
		#		set rotAlphabet to (characters 1 thru (rotFactor * 2) of rotAlphabet) as string
		if rotFactor is 5 then
			set rotAlphabet to (characters 27 thru (26 + rotFactor * 2) of rotAlphabet) as string
			#log "rotAlphabet: " & rotAlphabet
		end if
	end if
	#	log length of ascii33to126 # http://de.wikipedia.org/wiki/ROT13
	#if rotFactor is 13 then 
	
	(* Let's do this two times, on for every case :-) *)
	set lowerCaseRun to false
	repeat 2 times
		set rotAlphabet to (characters 1 thru (rotFactor * 2) of rotAlphabet) as string
		#log "FOO"
		considering case
			
			(* Walk through given string char by char *)
			repeat with char in givenString
				#	log ""
				#	log "char: " & char
				set p to offset of char in rotAlphabet
				if (p is not 0) then
					set r to (((p + rotFactor) mod (rotFactor * 2)))
					if r is 0 then set r to (rotFactor * 2)
					set rotChar to character r of rotAlphabet
					
				else
					(* Case didn't match *)
					set rotChar to char
				end if
				#		log "rotChar: " & rotChar
				set returnString to returnString & rotChar
			end repeat
			
		end considering
		
		(* start over, but this time lowercase :-) Weird solution! :-) *)
		if rotFactor is not 47 and rotFactor is not 5 and not lowerCaseRun then
			tell me to set rotAlphabet to lowerCase(rotAlphabet)
			set givenString to returnString
			set returnString to ""
			set lowerCaseRun to true
			if rotFactor is 18 then
				set rotFactor to 13 (* don't translate numbers AGAIN! (Just do the letters, cut the numbers *)
			end if
		else (* ROT 47 and ROT 5 don't have cases, so we need only one run *)
			exit repeat
		end if
		
	end repeat
	
	return returnString
end rotXX

to changeString of t from s to r
	set d to text item delimiters
	set text item delimiters to s
	set t to t's text items
	set text item delimiters to r
	tell t to set t to beginning & ({""} & rest)
	set text item delimiters to d
	t
end changeString

to lowerCase(s)
	set uc to "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	set lc to "abcdefghijklmnopqrstuvwxyz"
	repeat with i from 1 to 26
		set AppleScript's text item delimiters to character i of uc
		set s to text items of s
		set AppleScript's text item delimiters to character i of lc
		set s to s as text
	end repeat
	set AppleScript's text item delimiters to ""
	return s
end lowerCase
on logToConsole(someText)
	tell AppleScript
		try
			set cmd to "logger -p daemon.notice \"" & "LHS: " & someText & "\""
			do shell script cmd
		on error (e)
			log e
		end try
	end tell
end logToConsole

on logFrontMostProcess()
	(* Find the frontmost process *)
	tell application "System Events" to set fmps to (every process whose frontmost is true) -- and has scripting terminology is true)
	set fmp to first item in fmps
	
	(* Log name *)
	my logToConsole("Frontmost Process: " & name of fmp & " (" & short name of fmp & ")")
end logFrontMostProcess